const std = @import("std");

fn getParser(comptime parse_type: anytype) .{} {
    _ = parse_type;
}

fn makeStruct(comptime in: anytype) type {
    var fields: [in.len]std.builtin.TypeInfo.StructField = undefined;

    for (in, 0..) |t, i| {
        var fieldType: type = t[1];
        var fieldName: []const u8 = t[0][0..];
        fields[i] = .{
            .name = fieldName,
            .field_type = fieldType,
            .default_value = null,
            .is_comptime = false,
            .alignment = 0,
        };
    }

    const Payload = @Type(.{
        .Struct = .{
            .layout = .Auto,
            .fields = fields[0..],
            .decls = &[_]std.builtin.TypeInfo.Declaration{},
            .is_tuple = false,
        },
    });

    const retval = struct {
        const payloadType = Payload;

        fn get_next() Payload {}
    };

    return retval;
}
